/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Electronics Corporation and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Electronics Corporation and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
******************************************************************************
* Copyright (C) 2010-2013 Renesas Electronics Corporation.
* and Renesas Solutions Corporation. All rights reserved.
******************************************************************************
* File Name    : R_PG_RSPI_C0.c
* Version      : 1.00
* Device(s)    : 
* Tool-Chain   : 
* H/W Platform : 
* Description  : 
* Limitations  : 
******************************************************************************
* History : 20.05.2017 Version Description
*         :   
******************************************************************************/


/******************************************************************************
Includes   <System Includes> , "Project Includes"
******************************************************************************/
#include "r_pdl_spi.h"
#include "r_pdl_definitions.h"
#include "R_PG_IntFuncsExtern.h"


/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_Set_C0(void)
*
* Function Name: R_PG_RSPI_Set_C0
*
* Description  : RSPI`l̐ݒ
*
* Arguments    : Ȃ
*
* Return Value : true  : ݒ肪sꂽꍇ
*              : false : ݒɎsꍇ
*
* Calling Functions : R_SPI_Create
*                   : R_SPI_Set
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_Set_C0(void)
{
	bool res;

	res = R_SPI_Set(
		0,
		PDL_SPI_RSPCKA_PA5 | PDL_SPI_MOSIA_P16 | PDL_SPI_MISOA_P17,
		PDL_NO_DATA
	);

	if( !res ){
		return res;
	}

	return R_SPI_Create(
		0,
		PDL_SPI_MODE_SPI_MASTER | PDL_SPI_FULL_DUPLEX | PDL_SPI_PIN_MOSI_IDLE_LAST,
		PDL_SPI_BUFFER_64 | PDL_SPI_FRAME_1_4 | PDL_SPI_PARITY_NONE,
		PDL_SPI_CLOCK_DELAY_1 | PDL_SPI_SSL_DELAY_1 | PDL_SPI_NEXT_DELAY_1,
		0x17 | 0x80000000
	);

	return res;
}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_SetCommand_C0(void)
*
* Function Name: R_PG_RSPI_SetCommand_C0
*
* Description  : R}h̐ݒ
*
* Arguments    : Ȃ
*
* Return Value : true  : ݒ肪sꂽꍇ
*              : false : ݒɎsꍇ
*
* Calling Functions : R_SPI_Command
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_SetCommand_C0(void)
{
	bool res;

	res = R_SPI_Command(
		0,
		0,
		PDL_SPI_CLOCK_MODE_0 | PDL_SPI_DIV_1 | PDL_SPI_ASSERT_SSL0 | PDL_SPI_SSL_NEGATE | PDL_SPI_LENGTH_8 | PDL_SPI_MSB_FIRST,
		PDL_SPI_CLOCK_DELAY_MINIMUM | PDL_SPI_SSL_DELAY_MINIMUM | PDL_SPI_NEXT_DELAY_MINIMUM
	);

	if( !res ){
		return res;
	}

	return res;
}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_StartTransfer_C0(uint32_t * tx_start, uint32_t * rx_start, uint16_t sequence_loop_count)
*
* Function Name: R_PG_RSPI_StartTransfer_C0
*
* Description  : f[^̓]Jn
*
* Arguments    : uint32_t * tx_start : Mf[^̐擪̃AhX
*              : uint32_t * rx_start : Mf[^̊i[̐擪̃AhX
*              : uint16_t sequence_loop_count : R}hV[PX̌JԂ
*
* Return Value : true  : ݒ肪sꂽꍇ
*              : false : ݒɎsꍇ
*
* Calling Functions : R_SPI_Transfer
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_StartTransfer_C0(uint32_t * tx_start, uint32_t * rx_start, uint16_t sequence_loop_count)
{
	if( (tx_start == 0) || \
		(rx_start == 0) )
	{
		return false;
	}

	return R_SPI_Transfer(
		0,
		PDL_SPI_DMAC_DTC_TRIGGER_DISABLE,
		tx_start,
		rx_start,
		sequence_loop_count,
		Spi0IntFunc,
		15,
		Spi0ErIntFunc,
		15
	);

}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_GetStatus_C0(bool * idle)
*
* Function Name: R_PG_RSPI_GetStatus_C0
*
* Description  : ]Ԃ̎擾
*
* Arguments    : bool * idle : AChtO̊i[
*              :             : (0: ACh 1: ])
*
* Return Value : true  : 擾ɐꍇ
*              : false : 擾Ɏsꍇ
*
* Calling Functions : R_SPI_GetStatus
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_GetStatus_C0(bool * idle)
{
	uint16_t status;
	bool res;

	res = R_SPI_GetStatus(
		0,
		&status,
		PDL_NO_PTR
	);

	if( idle ){
		*idle = (status >> 1) & 0x01;
	}

	return res;
}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_GetError_C0(bool * over_run, bool * mode_fault, bool * parity_error)
*
* Function Name: R_PG_RSPI_GetError_C0
*
* Description  : G[oԂ̎擾
*
* Arguments    : bool * over_run : I[oG[tO̊i[
*              : bool * mode_fault : [htHgG[tO̊i[
*              : bool * parity_error : peBG[tO̊i[
*
* Return Value : true  : 擾ɐꍇ
*              : false : 擾Ɏsꍇ
*
* Calling Functions : R_SPI_GetStatus
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_GetError_C0(bool * over_run, bool * mode_fault, bool * parity_error)
{
	uint16_t status;
	bool res;

	res = R_SPI_GetStatus(
		0,
		&status,
		PDL_NO_PTR
	);

	if( over_run ){
		*over_run = status & 0x01;
	}
	if( mode_fault ){
		*mode_fault = (status >> 2) & 0x01;
	}
	if( parity_error ){
		*parity_error = (status >> 3) & 0x01;
	}

	return res;
}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_GetCommandStatus_C0(uint8_t * current_command, uint8_t * error_command)
*
* Function Name: R_PG_RSPI_GetCommandStatus_C0
*
* Description  : R}hԂ̎擾
*
* Arguments    : uint8_t * current_command : ݂̃R}h|C^(0`7)̊i[
*              : uint8_t * error_command : G[õR}h|C^(0`7)̊i[
*
* Return Value : true  : 擾ɐꍇ
*              : false : 擾Ɏsꍇ
*
* Calling Functions : R_SPI_GetStatus
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_GetCommandStatus_C0(uint8_t * current_command, uint8_t * error_command)
{
	uint16_t status;
	bool res;

	res = R_SPI_GetStatus(
		0,
		&status,
		PDL_NO_PTR
	);

	if( current_command ){	
		*current_command = (status >> 8) & 0x07;
	}
	if( error_command ){
		*error_command = (status >> 12) & 0x07;
	}

	return res;
}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_LoopBackDirect_C0(void)
*
* Function Name: R_PG_RSPI_LoopBackDirect_C0
*
* Description  : [vobN[h̐ݒiMf[^Mf[^j
*
* Arguments    : Ȃ
*
* Return Value : 
*
* Calling Functions : R_SPI_Control
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_LoopBackDirect_C0(void)
{
	return R_SPI_Control(
		0,
		PDL_SPI_LOOPBACK_DIRECT,
		PDL_NO_DATA
	);

}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_LoopBackReversed_C0(void)
*
* Function Name: R_PG_RSPI_LoopBackReversed_C0
*
* Description  : [vobN[h̐ݒiMf[^̔]Mf[^j
*
* Arguments    : Ȃ
*
* Return Value : 
*
* Calling Functions : R_SPI_Control
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_LoopBackReversed_C0(void)
{
	return R_SPI_Control(
		0,
		PDL_SPI_LOOPBACK_REVERSED,
		PDL_NO_DATA
	);

}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_LoopBackDisable_C0(void)
*
* Function Name: R_PG_RSPI_LoopBackDisable_C0
*
* Description  : [vobN[h̐ݒ
*
* Arguments    : Ȃ
*
* Return Value : 
*
* Calling Functions : R_SPI_Control
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_LoopBackDisable_C0(void)
{
	return R_SPI_Control(
		0,
		PDL_SPI_LOOPBACK_DISABLE,
		PDL_NO_DATA
	);

}

/******************************************************************************
* ID           : 
*
* Include      : 
*
* Declaration  : bool R_PG_RSPI_StopModule_C0(void)
*
* Function Name: R_PG_RSPI_StopModule_C0
*
* Description  : RSPI`l̒~
*
* Arguments    : Ȃ
*
* Return Value : true  : ~ɐꍇ
*              : false : ~Ɏsꍇ
*
* Calling Functions : R_SPI_Destroy
*
* Details      : ڍׂɂĂ̓t@X}jAQƂĂB
******************************************************************************/
bool R_PG_RSPI_StopModule_C0(void)
{
	return R_SPI_Destroy( 0 );

}



